package com.starcite.marketplace.concurrent;

import java.util.HashMap;
import java.util.UUID;
import java.util.concurrent.LinkedBlockingQueue;

/**
 * Created by StarCite.
 * User: andy.song
 * Date: Nov 18, 2010
 * Time: 11:53:49 AM
 * To change this template use File | Settings | File Templates.
 */
public class LinkedBlockingQueueTester {

    HashMap map;

    LinkedBlockingQueue<String> queue = new LinkedBlockingQueue<String>(Integer.MAX_VALUE);

    public class Input extends Thread {
        int i = 0;

        public void run() {
            while (true) {
                try {
                    long time = System.nanoTime();
                    queue.put(UUID.randomUUID().toString());
                    

                    System.out.println("Write cost " + (System.nanoTime() - time) + " nSec");
                    if (++i == 1000) {
                        break;
                    }
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    public class Output extends Thread {
        int i = 1000;

        public void run() {
            while (true) {
                long time = System.nanoTime();
                String value = queue.poll();
                //System.out.println(queue.poll());
                if (value != null) {
                    System.out.println("Read cost " + (System.nanoTime() - time) + " nSec");
                    if (--i == 0) {
                        break;
                    }
                }
            }
        }
    }

    public static void main(String[] args) {
        LinkedBlockingQueueTester tester = new LinkedBlockingQueueTester();

        int n = 16;

        for (int i = 0; i < n; ++i) {
            tester.new Input().start();
        }

        for (int i = 0; i < n; ++i) {
            tester.new Output().start();
        }


        //-Xbootclasspath/p:D:/tmp/distribution/lib/concurrent/jsr166.jar

    }


}
